#include "MSgarch.h"

//===========================================================================//
//===========================================================================//
//================================== sGARCH ==================================//
//===========================================================================//
//===========================================================================//
RCPP_MODULE(sGARCH){   
  // sGARCH-norm-symmetric
  class_<sGARCH_norm_sym>("sGARCH_norm_sym")  
	.constructor()
	.field( "name",        &sGARCH_norm_sym ::name )
	.field( "theta0",      &sGARCH_norm_sym ::theta0 )
	.field( "Sigma0",      &sGARCH_norm_sym ::Sigma0 )
	.field( "label",       &sGARCH_norm_sym ::label )
	.field( "lower",       &sGARCH_norm_sym ::lower )
	.field( "upper",       &sGARCH_norm_sym ::upper )
	.field( "ineq_lb",     &sGARCH_norm_sym ::ineq_lb )
	.field( "ineq_ub",     &sGARCH_norm_sym ::ineq_ub )
	.field( "NbParams",    &sGARCH_norm_sym ::NbParams )
	.field( "NbParamsModel",&sGARCH_norm_sym::NbParamsModel)
	.method( "f_sim",      &sGARCH_norm_sym ::f_sim )
	.method( "f_pdf",      &sGARCH_norm_sym ::f_pdf )
 .method( "f_pdf_its",  &sGARCH_norm_sym ::f_pdf_its )
	.method( "f_cdf",      &sGARCH_norm_sym ::f_cdf )
 .method( "f_cdf_its",  &sGARCH_norm_sym ::f_cdf_its )
	.method( "f_rnd",      &sGARCH_norm_sym ::f_rnd )
	.method( "calc_ht",    &sGARCH_norm_sym ::calc_ht )
	.method( "eval_model", &sGARCH_norm_sym ::eval_model )
	.method( "ineq_func",  &sGARCH_norm_sym ::ineq_func )
	.method( "f_unc_vol",  &sGARCH_norm_sym ::f_unc_vol)
  ;
  // sGARCH-std-symmetric
  class_<sGARCH_std_sym>("sGARCH_std_sym")  
    .constructor()
    .field( "name",        &sGARCH_std_sym ::name )
    .field( "theta0",      &sGARCH_std_sym ::theta0 )
    .field( "Sigma0",      &sGARCH_std_sym ::Sigma0 )
    .field( "label",       &sGARCH_std_sym ::label )
    .field( "lower",       &sGARCH_std_sym ::lower )
    .field( "upper",       &sGARCH_std_sym ::upper )
    .field( "ineq_lb",     &sGARCH_std_sym ::ineq_lb )
    .field( "ineq_ub",     &sGARCH_std_sym ::ineq_ub )
    .field( "NbParams",    &sGARCH_std_sym ::NbParams )
    .field( "NbParamsModel",&sGARCH_std_sym::NbParamsModel)
    .method( "f_sim",      &sGARCH_std_sym ::f_sim )
    .method( "f_pdf",      &sGARCH_std_sym ::f_pdf )
    .method( "f_pdf_its",  &sGARCH_std_sym ::f_pdf_its )
    .method( "f_cdf",      &sGARCH_std_sym ::f_cdf )
    .method( "f_cdf_its",  &sGARCH_std_sym ::f_cdf_its )
    .method( "f_rnd",      &sGARCH_std_sym ::f_rnd )
    .method( "calc_ht",    &sGARCH_std_sym ::calc_ht )
    .method( "eval_model", &sGARCH_std_sym ::eval_model )
    .method( "ineq_func",  &sGARCH_std_sym ::ineq_func )
    .method( "f_unc_vol",  &sGARCH_std_sym ::f_unc_vol)
  ;
  // sGARCH-ged-symmetric
  class_<sGARCH_ged_sym>("sGARCH_ged_sym")  
    .constructor()
    .field( "name",        &sGARCH_ged_sym ::name )
    .field( "theta0",      &sGARCH_ged_sym ::theta0 )
    .field( "Sigma0",      &sGARCH_ged_sym ::Sigma0 )
    .field( "label",       &sGARCH_ged_sym ::label )
    .field( "lower",       &sGARCH_ged_sym ::lower )
    .field( "upper",       &sGARCH_ged_sym ::upper )
    .field( "ineq_lb",     &sGARCH_ged_sym ::ineq_lb )
    .field( "ineq_ub",     &sGARCH_ged_sym ::ineq_ub )
    .field( "NbParams",    &sGARCH_ged_sym ::NbParams )
    .field( "NbParamsModel",&sGARCH_ged_sym::NbParamsModel)
    .method( "f_sim",      &sGARCH_ged_sym ::f_sim )
    .method( "f_pdf",      &sGARCH_ged_sym ::f_pdf )
    .method( "f_pdf_its",  &sGARCH_ged_sym ::f_pdf_its )
    .method( "f_cdf",      &sGARCH_ged_sym ::f_cdf )
    .method( "f_cdf_its",  &sGARCH_ged_sym ::f_cdf_its )
    .method( "f_rnd",      &sGARCH_ged_sym ::f_rnd )
    .method( "calc_ht",    &sGARCH_ged_sym ::calc_ht )
    .method( "eval_model", &sGARCH_ged_sym ::eval_model )
    .method( "ineq_func",  &sGARCH_ged_sym ::ineq_func )
    .method( "f_unc_vol",  &sGARCH_ged_sym ::f_unc_vol)
  ;
  
    // sGARCH-norm-skew
  class_<sGARCH_norm_skew>("sGARCH_norm_skew")  
	.constructor()
	.field( "name",        &sGARCH_norm_skew ::name )
	.field( "theta0",      &sGARCH_norm_skew ::theta0 )
	.field( "Sigma0",      &sGARCH_norm_skew ::Sigma0 )
	.field( "label",       &sGARCH_norm_skew ::label )
	.field( "lower",       &sGARCH_norm_skew ::lower )
	.field( "upper",       &sGARCH_norm_skew ::upper )
	.field( "ineq_lb",     &sGARCH_norm_skew ::ineq_lb )
	.field( "ineq_ub",     &sGARCH_norm_skew ::ineq_ub )
	.field( "NbParams",    &sGARCH_norm_skew ::NbParams )
	.field( "NbParamsModel",&sGARCH_norm_skew::NbParamsModel)
	.method( "f_sim",      &sGARCH_norm_skew ::f_sim )
	.method( "f_pdf",      &sGARCH_norm_skew ::f_pdf )
 .method( "f_pdf_its",  &sGARCH_norm_skew ::f_pdf_its )
	.method( "f_cdf",      &sGARCH_norm_skew ::f_cdf )
 .method( "f_cdf_its",  &sGARCH_norm_skew ::f_cdf_its )
	.method( "f_rnd",      &sGARCH_norm_skew ::f_rnd )
	.method( "calc_ht",    &sGARCH_norm_skew ::calc_ht )
	.method( "eval_model", &sGARCH_norm_skew ::eval_model )
	.method( "ineq_func",  &sGARCH_norm_skew ::ineq_func )
	.method( "f_unc_vol",  &sGARCH_norm_skew ::f_unc_vol)
  ;
  // sGARCH-std-skew
  class_<sGARCH_std_skew>("sGARCH_std_skew")  
    .constructor()
    .field( "name",        &sGARCH_std_skew ::name )
    .field( "theta0",      &sGARCH_std_skew ::theta0 )
    .field( "Sigma0",      &sGARCH_std_skew ::Sigma0 )
    .field( "label",       &sGARCH_std_skew ::label )
    .field( "lower",       &sGARCH_std_skew ::lower )
    .field( "upper",       &sGARCH_std_skew ::upper )
    .field( "ineq_lb",     &sGARCH_std_skew ::ineq_lb )
    .field( "ineq_ub",     &sGARCH_std_skew ::ineq_ub )
    .field( "NbParams",    &sGARCH_std_skew ::NbParams )
    .field( "NbParamsModel",&sGARCH_std_skew::NbParamsModel)
    .method( "f_sim",      &sGARCH_std_skew ::f_sim )
    .method( "f_pdf",      &sGARCH_std_skew ::f_pdf )
    .method( "f_pdf_its",  &sGARCH_std_skew ::f_pdf_its )
    .method( "f_cdf",      &sGARCH_std_skew ::f_cdf )
    .method( "f_cdf_its",  &sGARCH_std_skew ::f_cdf_its )
    .method( "f_rnd",      &sGARCH_std_skew ::f_rnd )
    .method( "calc_ht",    &sGARCH_std_skew ::calc_ht )
    .method( "eval_model", &sGARCH_std_skew ::eval_model )
    .method( "ineq_func",  &sGARCH_std_skew ::ineq_func )
    .method( "f_unc_vol",  &sGARCH_std_skew ::f_unc_vol)
  ;
  // sGARCH-ged-skew
  class_<sGARCH_ged_skew>("sGARCH_ged_skew")  
    .constructor()
    .field( "name",        &sGARCH_ged_skew ::name )
    .field( "theta0",      &sGARCH_ged_skew ::theta0 )
    .field( "Sigma0",      &sGARCH_ged_skew ::Sigma0 )
    .field( "label",       &sGARCH_ged_skew ::label )
    .field( "lower",       &sGARCH_ged_skew ::lower )
    .field( "upper",       &sGARCH_ged_skew ::upper )
    .field( "ineq_lb",     &sGARCH_ged_skew ::ineq_lb )
    .field( "ineq_ub",     &sGARCH_ged_skew ::ineq_ub )
    .field( "NbParams",    &sGARCH_ged_skew ::NbParams )
    .field( "NbParamsModel",&sGARCH_ged_skew::NbParamsModel)
    .method( "f_sim",      &sGARCH_ged_skew ::f_sim )
    .method( "f_pdf",      &sGARCH_ged_skew ::f_pdf )
    .method( "f_pdf_its",  &sGARCH_ged_skew ::f_pdf_its )
    .method( "f_cdf",      &sGARCH_ged_skew ::f_cdf )
    .method( "f_cdf_its",  &sGARCH_ged_skew ::f_cdf_its )
    .method( "f_rnd",      &sGARCH_ged_skew ::f_rnd )
    .method( "calc_ht",    &sGARCH_ged_skew ::calc_ht )
    .method( "eval_model", &sGARCH_ged_skew ::eval_model )
    .method( "ineq_func",  &sGARCH_ged_skew ::ineq_func )
    .method( "f_unc_vol",  &sGARCH_ged_skew ::f_unc_vol)
  ;


}
